@ECHO OFF

set device_name=Xiaomi 10
set rec_name=TWRP
set rec_ver=3.4.2b-0623
set rec_auth=wzsx150
set rec_team=LR.Team
set rec_date=2020.06.23
set rec_img=recovery-TWRP-3.4.2B-0623-XIAOMI10-CN-wzsx150.img

TITLE %device_name% One click flash TWRP - by wzsx150 - translate by MiFirm.net
color 6f

cd /d "%~dp0"

:LOGO
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.              RECOVERY INFORMATION
ECHO.
ECHO.              REC name :%rec_name%
ECHO.              REC version :%rec_ver%
ECHO.              Device name:%device_name%
ECHO.              Author:%rec_auth%
ECHO.              Team:%rec_team%
ECHO.              Release date:%rec_date%
ECHO.           
ECHO.     Support flash in normal mode and fastboot mode
ECHO.***********************************************
ECHO.
ECHO.Press any key to continue...
pause>nul

:MENU
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.             Your phone current mode:
ECHO.
ECHO.              1.Normal mode
ECHO.
ECHO.              2.Fastboot mode
ECHO.
ECHO.              3.Other mode
ECHO.
ECHO.
ECHO.***********************************************
ECHO.
set choice=
set /p choice=Please enter correct mode number then ENTER:
if not "%choice%"=="" set choice=%choice:~0,1%
if /i "%choice%"=="1" goto IN_SYSTEM
if /i "%choice%"=="2" goto FASTBOOT_MODE
if /i "%choice%"=="3" goto OTHERS
ECHO.
ECHO.Invalid input, please re-enter...
timeout /t 2 /nobreak >NUL
ECHO.
goto MENU


:OTHERS
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.             Please reboot phone to
ECHO.
ECHO.               Normal mode 
ECHO.                  or
ECHO.              Fastboot mode
ECHO.
ECHO.Press anykey to return back to main menu. It will automatically return if no key pressed in 6 secs.
ECHO.***********************************************
ECHO.
timeout /t 6 >nul
echo.
goto MENU


:IN_SYSTEM
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.        Please connect your phone to your computer
ECHO.
ECHO.            Make sure:
ECHO.      1.Phone is unlocked bootloader
ECHO.      2.Phone is screen on
ECHO.      3.USB debugging is enable
ECHO.      4.Driver installed on PC
ECHO.      5.When the phone prompts USB debugging authorization, check Always and click Authorize
ECHO.
ECHO.            Press any key to continue...
ECHO.***********************************************
ECHO.
pause>nul
ECHO.        Checking device connected...
ECHO.
ECHO.   If staying on this step too long, please check above information
ECHO.           And restart the phone
ECHO.***********************************************
ECHO.
timeout /t 2 /nobreak >NUL
adb.exe wait-for-device >NUL 2>NUL

CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.
ECHO.
ECHO.             The phone is restarting
ECHO.
ECHO.
ECHO.***********************************************
ECHO.
ECHO.   If staying on this step too long, please check above information
ECHO.
adb.exe reboot bootloader >NUL 2>NUL
timeout /t 3 /nobreak >NUL
goto FLASHING


:FASTBOOT_MODE
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.          Please connect your phone to your computer
ECHO.
ECHO.           Make sure:
ECHO.      1.Phone is unlocked bootloader
ECHO.      2.Phone in fastboot mode
ECHO.      3.Driver installed on PC
ECHO.
ECHO.            Press any key to continue...
ECHO.***********************************************
ECHO.
pause>nul
goto FLASHING


:FLASHING
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.
ECHO.          Checking device connected...
ECHO.
ECHO.
ECHO.      If staying on this step too long, please check
ECHO.
ECHO.      1.USB cable is connected
ECHO.      2.Driver install correctly
ECHO.      3.Phone is on fastboot mode
ECHO.
ECHO.             And restart the phone
ECHO.***********************************************
timeout /t 2 /nobreak >NUL
fastboot.exe wait-for-device >NUL 2>NUL

CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.
ECHO.
ECHO.             Flashing recovery...
ECHO.
ECHO.
ECHO.***********************************************
ECHO.
ECHO.      If OKAY is flash successfully, otherwise it fails
ECHO.
ECHO.    If staying on this step too long, please restart tool
ECHO.
fastboot.exe flash recovery "%rec_img%" || goto FLASH_FAILED
REM fastboot.exe flash misc misc.bin >NUL 2>NUL
timeout /t 6 /nobreak >NUL
goto FLASH_OVER


:FLASH_FAILED
ECHO.
ECHO. SOMETHING WENT WRONG!
timeout /t 6 /nobreak >NUL
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.
ECHO.                   Flash failed
ECHO.
ECHO.           1. Please check model is correct
ECHO.           2. Make sure fastboot is correct
ECHO.           3. Run the program again
ECHO.              If still not successful, please contact author
ECHO.
ECHO.           %rec_auth% thank you for use this tool
ECHO.
ECHO.            Press any key to exit...
ECHO.***********************************************
ECHO.
timeout /t 1 /nobreak >NUL
pause >NUL
EXIT


:FLASH_OVER
CLS
ECHO.
ECHO.         %device_name% One click flash TWRP - translate by MiFirm.net
ECHO.***********************************************
ECHO.
ECHO.             Flash recovery complete
ECHO.
ECHO.
ECHO.        The phone will restart to %rec_name%
ECHO.            Phone may restart 1-2 times
ECHO.
ECHO.
ECHO.           %rec_auth% thank you for use this tool
ECHO.
ECHO.           Press any key to exit...
ECHO.***********************************************
ECHO.
fastboot.exe reboot recovery
pause >NUL

EXIT


